#include <l4/names/libnames.h>
#include <l4/env/errno.h>
#include <l4/sys/consts.h>
#include <l4/clock/clock.h>

static l4_threadid_t server_id = L4_INVALID_ID;
static CORBA_Object server = &server_id;

static int check_server(void)
{
	if(l4_is_invalid_id(server_id))
	{
		if(!names_waitfor_name("clock", &server_id,10000))
			return 1;
	}
	return 0;
}

int clock_gettime(clockid_t clk_id, struct timespec *tp)
{
	CORBA_Environment env = dice_default_environment;
	int result;
	if(check_server())return -L4_EINVAL;
	result = clock_gettime_call(server,clk_id,tp, &env);
	if(!env._p.ipc_error)return result;
	return -env._p.ipc_error;
}

int clock_nanosleep(clockid_t clk_id, int flags, struct timespec *rqtp, struct timespec *rmtp)
{
	CORBA_Environment env = dice_default_environment;
	int result;
	if(check_server())return -L4_EINVAL;
	result = clock_nanosleep_call(server,clk_id,flags,rqtp,rmtp,&env);
	if(!env._p.ipc_error)return result;
	return -env._p.ipc_error;
}
